Bug 1764242 - glibc: Enhancements for LLVM toolset
Summary: glibc: Enhancements for LLVM toolset
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: glibc
Version: 8.2
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 8.2
Assignee: Florian Weimer
QA Contact: qe-baseos-tools-bugs
URL:
Whiteboard:
Depends On:
Blocks: 1746918
TreeView+ depends on / blocked
 
Reported: 2019-10-22 14:09 UTC by Florian Weimer
Modified: 2020-04-28 16:50 UTC (History)
7 users (show)

Fixed In Version: glibc-2.28-88.el8
Doc Type: No Doc Update
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-04-28 16:50:25 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:1828 None None None 2020-04-28 16:50:36 UTC

Description Florian Weimer 2019-10-22 14:09:16 UTC
We should backport this enhancement to benefit Clang:

commit 4997e8f31e7415652c3dedec672c0e9bf8caa9ca
Author: Adhemerval Zanella <adhemerval.zanella@linaro.org>
Date:   Fri Feb 1 10:39:57 2019 -0200

    math: Enable some math builtins for clang
    
    This patch enable the builtin usage for clang for the C99 functions
    fpclassify, isfinite, isnormal, isnan, isinf, and sigbit.  This allows
    clang optimize the calls on frontend instead of call the appropriate
    glibc symbols.
    
    Checked on aarch64-linux-gnu and x86_64-linux-gnu. I checked the supported
    version for each builtin based on released version from clang/llvm.
    
            * math/math.h (fpclassify, isfinite, isnormal, isnan): Use builtin for
            clang 2.8.
            (signbit): Use builtin for clang 3.3.
            (isinf): Use builtin for clang 3.7.

This should also be backported into Fedora 30+.

Comment 4 Sergey Kolosov 2020-02-20 13:33:03 UTC
Verified, glibc uses __builtin versions of fpclassify signbit isfinite isnormal isnan isinf functions with clang.

Comment 6 errata-xmlrpc 2020-04-28 16:50:25 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:1828


Note You need to log in before you can comment on or make changes to this bug.